package cn.iocoder.yudao.module.pms.service.qhse.cert;

import cn.iocoder.yudao.framework.common.exception.ErrorCode;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;
import cn.iocoder.yudao.module.pms.controller.admin.qhse.cert.vo.QhseOrgCertPageReqVO;
import cn.iocoder.yudao.module.pms.controller.admin.qhse.cert.vo.QhseOrgCertSaveReqVO;
import cn.iocoder.yudao.module.pms.dal.dataobject.qhse.cert.QhseOrgCertDO;
import cn.iocoder.yudao.module.pms.dal.mysql.qhse.cert.QhseOrgCertMapper;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;

import java.time.LocalDateTime;
import java.time.temporal.ChronoUnit;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;

/**
 * QHSE组织证书管理 Service 实现类
 *
 * @author 超级管理员
 */
@Service
@Validated
public class QhseOrgCertServiceImpl implements QhseOrgCertService {

    @Resource
    private QhseOrgCertMapper qhseOrgCertMapper;

    @Override
    public Long createQhseOrgCert(QhseOrgCertSaveReqVO createReqVO) {
        // 插入
        QhseOrgCertDO qhseOrgCert = BeanUtils.toBean(createReqVO, QhseOrgCertDO.class);
        qhseOrgCert.setDeleted(false);
        qhseOrgCert.setAlertWarn(false);
        qhseOrgCert.setExpired(false);
        LocalDateTime certExpire = qhseOrgCert.getCertExpire();
        //证书已过期的话，更新expired为true
        if (certExpire.isBefore(LocalDateTime.now())) {
            //证书已过期的话，更新expired为true
            qhseOrgCert.setExpired(true);
        } else  {
            if (ChronoUnit.DAYS.between(LocalDateTime.now(), certExpire) < 60) {
                qhseOrgCert.setAlertWarn(true);//设置为60天预警过期
            }
            qhseOrgCert.setExpired(false);
        }
        qhseOrgCertMapper.insert(qhseOrgCert);
        // 返回
        return qhseOrgCert.getId();
    }

    @Override
    public void updateQhseOrgCert(QhseOrgCertSaveReqVO updateReqVO) {
        // 校验存在
        validateQhseOrgCertExists(updateReqVO.getId());
        // 更新
        QhseOrgCertDO updateObj = BeanUtils.toBean(updateReqVO, QhseOrgCertDO.class);
        LocalDateTime certExpire = updateObj.getCertExpire();
        //证书已过期的话，更新expired为true
        if (certExpire.isBefore(LocalDateTime.now())) {
            //证书已过期的话，更新expired为true
            updateObj.setExpired(true);
        } else  {
            if (ChronoUnit.DAYS.between(LocalDateTime.now(), certExpire) < 60) {
                updateObj.setAlertWarn(true);//设置为60天预警过期
            }
            updateObj.setExpired(false);
        }
        qhseOrgCertMapper.updateById(updateObj);
    }

    @Override
    public void deleteQhseOrgCert(Long id) {
        // 校验存在
        validateQhseOrgCertExists(id);
        // 删除
        qhseOrgCertMapper.deleteById(id);
    }

    private void validateQhseOrgCertExists(Long id) {
        if (qhseOrgCertMapper.selectById(id) == null) {
            throw exception(new ErrorCode(1, "不存在"));
        }
    }

    @Override
    public QhseOrgCertDO getQhseOrgCert(Long id) {
        return qhseOrgCertMapper.selectById(id);
    }

    @Override
    public PageResult<QhseOrgCertDO> getQhseOrgCertPage(QhseOrgCertPageReqVO pageReqVO) {
        return qhseOrgCertMapper.selectPage(pageReqVO);
    }

}